/*----------------------------------------------------------------------- 
 * 
 * File Name: InspiralExch.h
 *
 * Author: Allen, B., Brown, D. A. and Creighton, J. D. E.
 * 
 * Revision: $Id: InspiralExch.h,v 1.2 2003/06/09 05:06:25 duncan Exp $
 * 
 *-----------------------------------------------------------------------
 */

#if 0
<lalVerbatim file="InspiralExchHV">
Author: Allen, B., Brown, D. A. and Creighton, J. D. E.
$Id: InspiralExch.h,v 1.2 2003/06/09 05:06:25 duncan Exp $
</lalVerbatim> 

<lalLaTeX>

\section{Header \texttt{InspiralExch.h}}
\label{s:InspiralExch.h}

Provides routines for MPI communication of various \texttt{findchirp} specific
data types.

\subsection*{Synopsis}

\begin{verbatim}
#include <InspiralExch.h>
\end{verbatim}

</lalLaTeX>
#endif

#ifndef _INSPIRALEXCHH_H
#define _INSPIRALEXCHH_H

#include <lal/LALDatatypes.h>
#include <lal/Comm.h>
#include <lal/LIGOMetadataTables.h>
#include <lal/LALInspiral.h>
#include <lal/FindChirp.h>
#include <lal/FindChirpEngine.h>

#ifdef  __cplusplus
extern "C" {
#endif


NRCSID (INSPIRALEXCHH, "$Id: InspiralExch.h,v 1.2 2003/06/09 05:06:25 duncan Exp $");

#if 0
<lalLaTeX> 
\subsection*{Error codes} 
</lalLaTeX>
#endif
/* <lalErrTable> */
#define INSPIRALEXCHH_ENULL 1
#define INSPIRALEXCHH_ENNUL 2
#define INSPIRALEXCHH_ENOBJ 4
#define INSPIRALEXCHH_EHAND 8
#define INSPIRALEXCHH_EMPIE 16
#define INSPIRALEXCHH_MSGENULL "Null pointer"
#define INSPIRALEXCHH_MSGENNUL "Non-null pointer"
#define INSPIRALEXCHH_MSGENOBJ "Invalid number of objects"
#define INSPIRALEXCHH_MSGEHAND "Wrong handshake"
#define INSPIRALEXCHH_MSGEMPIE "Problem exchanging event list"
/* </lalErrTable> */

#if 0
<lalLaTeX>
\subsection*{Types}
</lalLaTeX>
#endif

#if 0
<lalLaTeX>
\vfill{\footnotesize\input{InspiralExchHV}}
</lalLaTeX> 
#endif

#if 0
<lalLaTeX>
\newpage\input{InspiralExchC}
</lalLaTeX>
#endif

void
ExchangeInspiralTemplate (
    LALStatus           *status,
    InspiralTemplate *tmplt,
    ExchParams       *exchParams
    );

void
ExchangeInspiralEvent (
    LALStatus        *status,
    SnglInspiralTable *event,
    ExchParams    *exchParams
    );

void
ExchangeInspiralEventList (
    LALStatus     *status,
    SnglInspiralTable **eventHead,
    ExchParams    *exchParams
    );

void
ExchangeTemplateBank (
    LALStatus         *status,
    InspiralTemplate **tmpltHead,
    ExchParams        *exchParms
                 );

#ifdef  __cplusplus
}
#endif

#endif /* _INSPIRALEXCHH_H */
