/**** <lalVerbatim file="TFCApplySearchHV"> ***********
Author: Julien Sylvestre
 $Id: ApplySearch.h,v 1.9 2002/08/13 19:47:32 julien Exp $
***** </lalVerbatim> ***********************************/

#ifndef _APPLYSEARCH_H
#define _APPLYSEARCH_H

#include <LALWrapperInterface.h>
#include <lal/LALDatatypes.h>
#include <lal/LALRCSID.h>
#include <lal/Comm.h>

#include <InitSearch.h>

#ifdef  __cplusplus
extern "C" {
#endif


NRCSID (APPLYSEARCHH, "power $Id: ApplySearch.h,v 1.9 2002/08/13 19:47:32 julien Exp $");

/******** <lalErrTable file="TFCApplySearchHErrTab"> ********/
#define APPLYSEARCHH_ENULL 11
#define APPLYSEARCHH_ENNUL 12
#define APPLYSEARCHH_EALOC 13
#define APPLYSEARCHH_ENUMZ 14
#define APPLYSEARCHH_EDELT 18
#define APPLYSEARCHH_ERANK 19
#define APPLYSEARCHH_EUEXT 110
#define APPLYSEARCHH_EDELF 111
#define APPLYSEARCHH_ENDAT 111
#define APPLYSEARCHH_EIERR 112
#define APPLYSEARCHH_ETHREAD 113
#define APPLYSEARCHH_EMAXBLOB 114

#define APPLYSEARCHH_MSGENULL "Null pointer"
#define APPLYSEARCHH_MSGENNUL "Non-null pointer"
#define APPLYSEARCHH_MSGEALOC "Memory allocation error"
#define APPLYSEARCHH_MSGENUMZ "Data segment length is zero"
#define APPLYSEARCHH_MSGEDELT "deltaT is zero or negative"
#define APPLYSEARCHH_MSGERANK "Search node has incorrect rank"
#define APPLYSEARCHH_MSGEUEXT "Unrecognised exchange type"
#define APPLYSEARCHH_MSGEDELF "Inconsistent deltaF in spectrum and data"
#define APPLYSEARCHH_MSGENDAT "Total number of data not a multiple of (segment length - overlap)"
#define APPLYSEARCHH_MSGEIERR  "Internal error"
#define APPLYSEARCHH_MSGETHREAD "Thread error"
#define APPLYSEARCHH_MSGEMAXBLOB "Maximum allowed BLOB size (! Mo) exceeded"
/******** </lalErrTable> ********/

enum
{
  ExchDataSegment,
  ExchDataList,
  ExchEPEvent,
  ExchFinished,
  ExchBeacon
}
ExchObjectType;


typedef struct tagTArg {

  char on;
  InitExchParams *init;

} TArg;

static void
LALExchangeTFCList (
		    LALStatus *status,
		    CList **clist,
		    LIGOTimeGPS *epch,
		    ExchParams       *exchParams
		    );

static void BuildTFCOutput(LALStatus *status,
			   LALSearchOutput *output,
			   CList *list,
			   UINT4 t0Sec,
			   UINT4 t0NanoSec,
			   char *name,
			   DbTable table,
			   REAL4 *resp,
			   REAL4 *spec,
			   BOOLEAN TFC_BLOB__,
			   REAL8 tDuration,
			   UINT4 numSlaves);

#ifdef  __cplusplus
}
#endif

#endif /* _APPLYSEARCH_H */
