/**** <lalVerbatim file="TSExchHV"> ***********
Author: Torres, Charlie
$Id: TSExch.h,v 1.1 2003/10/08 15:05:11 jolien Exp $
***** </lalVerbatim> ***********************************/

#ifndef _TSEXCH_H
#define _TSEXCH_H

#include <lal/LALDatatypes.h>
#include <lal/Comm.h>
#include <lal/DataBuffer.h>
#include <lal/FindChirp.h>
#include <lal/ExcessPower.h>
#include <lal/BurstSearch.h>
#include <lal/EPData.h>  /* switch to equivalent header for tracksearch */
#include <lal/TrackSearch.h>
#include "TrackSearchApplySearch.h"

#ifdef  __cplusplus
extern "C" {
#endif


NRCSID (EPEXCHH, "$Id: TSExch.h,v 1.1 2003/10/08 15:05:11 jolien Exp $");

/******** <lalErrTable file="EPExchHErrTab"> ********/
#define TSEXCH_ENULL 1
#define TSEXCH_ENNUL 2
#define TSEXCH_ENOBJ 4
#define TSEXCH_EHAND 8
#define TSEXCH_EMPIE 16

#define TSEXCH_MSGENULL "Null pointer"
#define TSEXCH_MSGENNUL "Non-null pointer"
#define TSEXCH_MSGENOBJ "Invalid number of objects"
#define TSEXCH_MSGEHAND "Wrong handshake"
#define TSEXCH_MSGEMPIE "Problem exchanging event list"
/******** </lalErrTable> ********/

typedef enum
{
  ExchDataSegment,
  ExchDataList,
  ExchTSEvent,
  ExchFinished
}
ExchObjectType;

void
LALExchangeTSEvent (
    LALStatus           *status,
    TrackSearchEvent    *event,
    ExchParams          *exchParams
    );

void
LALExchangeTSEventList (
    LALStatus           *status,
    TrackSearchEvent   **eventHead,
    INT4                 numEvents,
    ExchParams          *exchParams
    );

#ifdef  __cplusplus
}
#endif

#endif /* _TSEXCH_H */
