
/**** <lalVerbatim file="TrackSearchApplySearchHV"> ***********
Author: Torres, Charlie
 $Id: TrackSearchApplySearch.h,v 1.1 2003/10/08 15:05:11 jolien Exp $
***** </lalVerbatim> ***********************************/

#ifndef _APPLYSEARCH_H
#define _APPLYSEARCH_H

#include <lal/EPData.h>
#include <lal/TSData.h>
#include <lal/TSSearch.h>
#include <lal/TFTransform.h>
#include "LALWrapperInterface.h"

#ifdef  __cplusplus
extern "C" {
#endif


NRCSID (APPLYSEARCHH, "tracksearch $Id: TrackSearchApplySearch.h,v 1.1 2003/10/08 15:05:11 jolien Exp $");

/******** <lalErrTable file="TrackSearchApplySearchHErrTab"> ********/
#define TRACKSEARCHAPPLYSEARCHH_ENULL 1
#define TRACKSEARCHAPPLYSEARCHH_ENNUL 2
#define TRACKSEARCHAPPLYSEARCHH_EALOC 3
#define TRACKSEARCHAPPLYSEARCHH_ENUMZ 4
#define TRACKSEARCHAPPLYSEARCHH_EDELT 8
#define TRACKSEARCHAPPLYSEARCHH_ERANK 9
#define TRACKSEARCHAPPLYSEARCHH_EUEXT 10
#define TRACKSEARCHAPPLYSEARCHH_EDELF 11
#define TRACKSEARCHAPPLYSEARCHH_ELOCF 12

#define TRACKSEARCHAPPLYSEARCHH_MSGENULL "Null pointer"
#define TRACKSEARCHAPPLYSEARCHH_MSGENNUL "Non-null pointer"
#define TRACKSEARCHAPPLYSEARCHH_MSGEALOC "Memory allocation error"
#define TRACKSEARCHAPPLYSEARCHH_MSGENUMZ "Data segment length is zero"
#define TRACKSEARCHAPPLYSEARCHH_MSGEDELT "deltaT is zero or negative"
#define TRACKSEARCHAPPLYSEARCHH_MSGERANK "Search node has incorrect rank"
#define TRACKSEARCHAPPLYSEARCHH_MSGEUEXT "Unrecognised exchange type"
#define TRACKSEARCHAPPLYSEARCHH_MSGEDELF "Inconsistent deltaF in spectrum and data"
#define TRACKSEARCHAPPLYSEARCHH_MSGELOCF "Error in local function"
/******** </lalErrTable> ********/

#define TRACKSEARCHAPPLYSEARCHH_SEARCHNAME "tracksearch"
#define TRACKSEARCHAPPLYSEARCHH_STRLENGTH 10

typedef struct
tagTrackSearchEventMap
{
  REAL8                            mapStartTime;
  REAL8                            mapEndTime;
  Curve                           *curvelist; /*LAL Datatype */
  struct tagTrackSearchEventMap   *nextEvent; /*New Event map*/
}
  TrackSearchEventMap;

typedef struct
tagTrackSearchEvent
{
  LIGOTimeGPS                         mapStartTime;
  UINT4                               durationPoints;
  UINT4                               FreqBins;
  UINT4                               TimeBins;
  WindowType                          window;
  UINT4                               windowsize;
  UINT4                               overlap; /* Points for overlap */
  UINT4                               TstartPixel;
  UINT4                               FstartPixel;
  UINT4                               TstopPixel;
  UINT4                               FstopPixel;
  REAL8                               peakPixelPower;
  UINT4                               peakPixelT;
  UINT4                               peakPixelF;
  REAL8                               power;
  REAL4Vector                        *fvalues;
  REAL4Vector                        *tvalues;
  UINT4                               junction; /* 1 yes 0 no*/
  struct tagTrackSearchEvent         *nextEvent; /* Pointer for linked listing */
}  TrackSearchEvent;

typedef struct
tagTrackSearchEventList
{
  TrackSearchEvent             *eventlist;    /*Array of maps with events*/
  CHAR                         *ifo;          /*IFO used*/
  CHAR                         *channel;      /*Data channel analyzed*/
  UINT4                         numEventMaps; /*Number of maps with any event*/
}
TrackSearchEventList;
  
void
BuildTrackSearchOutput (
			LALStatus               *status,
			LALSearchOutput         *output,
			TrackSearchEventList    *eventlist,
			TSSearchParams          *params
			);

#ifdef  __cplusplus
}
#endif

#endif /* _TRACKSEARCHAPPLYSEARCH_H */
