/**** <lalVerbatim file="PowerConditionDataHV"> ***********
Author: Torres, C
$Id: TrackSearchConditionData.h,v 1.2 2003/10/08 19:48:24 jolien Exp $
***** </lalVerbatim> ***********************************/

#ifndef _TRACKSEARCHCONDITIONDATA_H
#define _TRACKSEARCHCONDITIONDATA_H

#include "LALWrapperInterface.h"
#include <lal/TSSearch.h>
/*#include "Power.h" DOES THIS BELONG*/

#ifdef  __cplusplus
extern "C" {
#endif

NRCSID (TRACKSEARCHCONDITIONDATAH, "tracksearch $Id: TrackSearchConditionData.h,v 1.2 2003/10/08 19:48:24 jolien Exp $");

/******** <lalErrTable file="TrackSearchConditionDataHErrTab"> ********/
#define TRACKSEARCHCONDITIONDATAH_ENULL     1
#define TRACKSEARCHCONDITIONDATAH_ENNUL     2
#define TRACKSEARCHCONDITIONDATAH_EALOC     3
#define TRACKSEARCHCONDITIONDATAH_EARGS     4
#define TRACKSEARCHCONDITIONDATAH_EINPUT    5
#define TRACKSEARCHCONDITIONDATAH_EDT       6
#define TRACKSEARCHCONDITIONDATAH_EDTZ      7
#define TRACKSEARCHCONDITIONDATAH_ENUMZ     8
#define TRACKSEARCHCONDITIONDATAH_ESEGZ     9
#define TRACKSEARCHCONDITIONDATAH_EDATZ     10
#define TRACKSEARCHCONDITIONDATAH_ESPEC     11
#define TRACKSEARCHCONDITIONDATAH_ESUBR     12

#define TRACKSEARCHCONDITIONDATAH_MSGENULL   "Null pointer"
#define TRACKSEARCHCONDITIONDATAH_MSGENNUL   "Non-null pointer"
#define TRACKSEARCHCONDITIONDATAH_MSGEALOC   "Memory allocation error"
#define TRACKSEARCHCONDITIONDATAH_MSGEARGS   "Wrong number of arguments"
#define TRACKSEARCHCONDITIONDATAH_MSGEINPUT  "Wrong data names in input structure"
#define TRACKSEARCHCONDITIONDATAH_MSGEDT     "Mismatch between deltaT in wrapperParams and inPut"
#define TRACKSEARCHCONDITIONDATAH_MSGEDTZ    "wrapperParams->deltaT is zero or negative"
#define TRACKSEARCHCONDITIONDATAH_MSGENUMZ   "Data segment length is zero"
#define TRACKSEARCHCONDITIONDATAH_MSGESEGZ   "Number of data segments is zero"
#define TRACKSEARCHCONDITIONDATAH_MSGEDATZ   "Got less data than expected"
#define TRACKSEARCHCONDITIONDATAH_MSGESPEC   "Unrecognized power spectrum type"
#define TRACKSEARCHCONDITIONDATAH_MSGESUBR   "Condition Data Internal Subroutine Failure"
/******** </lalErrTable> ********/

/* the names of the multidim data channels */
#define INPUTNAME_CHANNEL   "channel"
#define INPUTNAME_SPECTRUM  "spectrum"
#define INPUTNAME_RESPONSE  "response"

#ifdef  __cplusplus
}
#endif

#endif /* _TRACKSEARCHCONDITIONDATA_H */

void TrackSearchPrep(
		     LALStatus               *status,
		     REAL4Vector             *TSSearchData,
		     COMPLEX8Vector          *TSSearchResponse,
		     REAL4Vector             *TSSearchSpectrum,
		     TSSegmentVector         *PreparedData,
		     UINT4                   SegToCreate,
		     UINT4                   DataSegLength
		     );
