dnl $Id: ExtractTimeSeries.m4,v 1.3 2003/02/07 17:11:53 jolien Exp $
ifelse(TYPECODE,`Z',`define(`TYPE',`COMPLEX16')define(`MDDTYPE',`complex16')')
ifelse(TYPECODE,`C',`define(`TYPE',`COMPLEX8')define(`MDDTYPE',`complex8')')
ifelse(TYPECODE,`D',`define(`TYPE',`REAL8')define(`MDDTYPE',`real8')')
ifelse(TYPECODE,`S',`define(`TYPE',`REAL4')define(`MDDTYPE',`real4')')
ifelse(TYPECODE,`I2',`define(`TYPE',`INT2')define(`MDDTYPE',`int2s')')
ifelse(TYPECODE,`I4',`define(`TYPE',`INT4')define(`MDDTYPE',`int4s')')
ifelse(TYPECODE,`I8',`define(`TYPE',`INT8')define(`MDDTYPE',`int8s')')
ifelse(TYPECODE,`U2',`define(`TYPE',`UINT2')define(`MDDTYPE',`int2u')')
ifelse(TYPECODE,`U4',`define(`TYPE',`UINT4')define(`MDDTYPE',`int4u')')
ifelse(TYPECODE,`U8',`define(`TYPE',`UINT8')define(`MDDTYPE',`int8u')')
define(`STYPE',`format(`%sTimeSeries',TYPE)')
define(`FUNC',`format(`LALExtract%s',STYPE)')
define(`VFUNC',`format(`LAL%sCreateVector',TYPECODE)')

/* <lalVerbatim file="ExtractSeriesCP"> */
void
FUNC (
    LALStatus           *status,
    STYPE       *series,
    multiDimData        *input
    )
{ /* </lalVerbatim> */
  INITSTATUS( status, "FUNC", EXTRACTSERIESC );
  ATTATCHSTATUSPTR( status );

  ASSERT( input, status, EXTRACTSERIES_ENULL, EXTRACTSERIES_MSGENULL );
  ASSERT( series, status, EXTRACTSERIES_ENULL, EXTRACTSERIES_MSGENULL );
  ASSERT( ! series->data || ! series->data->data, status,
      EXTRACTSERIES_ENNUL, EXTRACTSERIES_MSGENNUL );
  
  if ( input->space != timeD ) /* check series type */
  {
    ABORT( status, EXTRACTSERIES_ESERT, EXTRACTSERIES_MSGESERT );
  }
  if ( CheckDataType( input->type, "TYPECODE" ) ) /* check data type */
  {
    ABORT( status, EXTRACTSERIES_ETYPE, EXTRACTSERIES_MSGETYPE );
  }

  /* copy the metadata */
  strncpy( series->name, input->name, sizeof( series->name ) );
  series->epoch.gpsSeconds     = input->range.dTime.startSec;
  series->epoch.gpsNanoSeconds = input->range.dTime.startNan;
  series->deltaT               = input->range.dTime.timeStepSize;
  series->f0                   = input->range.dTime.baseFreq;
  /* FIXME: what to do about units? */

  /*
   * Copy the data... there are several modes:
   *   1. If series->data is NULL, create it and copy data here.
   *   2. If series->data->data is NULL, just copy pointer to data.
   *   3. If series->data->data is not NULL, this is an error.
   */
  if ( series->data )
  {
    if ( series->data->data )
    {
      ABORT( status, EXTRACTSERIES_ENNUL, EXTRACTSERIES_MSGENNUL );
    }
    series->data->length = input->range.dTime.numberSamples;
    series->data->data   = input->data.MDDTYPE;
  }
  else
  {
    TRY( VFUNC ( status->statusPtr, &series->data,
        input->range.dTime.numberSamples ), status );
    memcpy( series->data->data, input->data.MDDTYPE,
        series->data->length * sizeof( *series->data->data ) );
  }

  DETATCHSTATUSPTR( status );
  RETURN( status );
}
